import { _ as __extends, a as __assign } from "./tslib.es6-f5d753a9.js";
import { j as jsxRuntimeExports } from "./index-1b71ec1c.js";
import React, { createRef, Component } from "react";
import ReactDOM from "react-dom";
import CanvasWithContext from "./Canvas.js";
import "./TopBar.js";
import "./RectTools.js";
import "./AttributesTools.js";
import "./Input.js";
import "./EllipseTools.js";
import "./CircleTools.js";
import "./PathTools.js";
import "./TextTools.js";
import "./GenericTools.js";
import "./IconButton.js";
import "./Icon.js";
import "./DelDupTools.js";
import "./GroupTools.js";
import "./canvasContext-309e1cd4.js";
import "./LeftBar.js";
import "./BottomBar.js";
import "./ColorButton.js";
var VERSION = require("./package.json").version;
var Editor = (
  /** @class */
  function(_super) {
    __extends(Editor2, _super);
    function Editor2(props) {
      var _this = this;
      var _a, _b, _c, _d, _e;
      _this = _super.call(this, props) || this;
      _this.svgContent = "";
      _this.svgUpdate = function(svgContent) {
        _this.logDebugData("svgUpdate", _this.config.saveHandler !== null);
        _this.svgContent = svgContent;
        if (_this.config.saveHandler !== null) {
          _this.config.saveHandler(_this.svgContent);
        }
      };
      _this.onClose = function() {
        _this.logDebugData("onClose", _this.config.onCloseHandler !== null);
        _this.containerRef.current && ReactDOM.unmountComponentAtNode(_this.containerRef.current);
        if (!!_this.config.onCloseHandler) {
          _this.config.onCloseHandler();
        }
      };
      _this.logDebugData = function(functionName, args) {
        var _a2;
        if (_this.config.debug) {
          console.info("%c%s", "color:green", _this.config.debugPrefix, functionName, args, (_a2 = new Error().stack) === null || _a2 === void 0 ? void 0 : _a2.split(/\n/)[2]);
        }
      };
      _this.containerRef = createRef();
      _this.svgContent = props.svgContent;
      _this.config = {
        debug: ((_a = props.config) === null || _a === void 0 ? void 0 : _a.debug) !== void 0 ? props.config.debug : true,
        i18n: ((_b = props.config) === null || _b === void 0 ? void 0 : _b.i18n) !== void 0 ? props.config.i18n : "en",
        saveHandler: ((_c = props.config) === null || _c === void 0 ? void 0 : _c.saveHandler) !== void 0 ? props.config.saveHandler : null,
        onCloseHandler: ((_d = props.config) === null || _d === void 0 ? void 0 : _d.onCloseHandler) !== void 0 ? props.config.onCloseHandler : null,
        debugPrefix: ((_e = props.config) === null || _e === void 0 ? void 0 : _e.debugPrefix) !== void 0 ? props.config.debugPrefix : "editor"
      };
      return _this;
    }
    Editor2.prototype.componentDidUpdate = function() {
    };
    Editor2.prototype.load = function(svgContent) {
      this.logDebugData("load", svgContent === null || svgContent === void 0 ? void 0 : svgContent.length);
      try {
        ReactDOM.render(React.createElement(CanvasWithContext, {
          svgContent,
          locale: this.config.i18n,
          svgUpdate: this.svgUpdate,
          onClose: this.onClose,
          log: this.logDebugData
        }, null), this.containerRef.current);
      } catch (err) {
        console.error("could not load the SVG content", err);
        throw err;
      }
    };
    Editor2.prototype.info = function() {
      console.info("Editor version:", VERSION);
      var info = {
        version: VERSION,
        currentConfig: this.config,
        container: this.containerRef.current
      };
      return info;
    };
    Editor2.prototype.getSvg = function() {
      this.logDebugData("getSvg");
      return this.svgContent;
    };
    Editor2.prototype.configure = function(name, value) {
      this.logDebugData("configure", { name, value });
      if (typeof this.config[name] === "undefined") {
        throw new Error("".concat(name, " is not a valid configuration"));
      }
      this.config[name] = value;
      return this.config;
    };
    Editor2.prototype.render = function() {
      var props = {
        svgContent: this.props.svgContent,
        locale: this.config.i18n,
        svgUpdate: this.svgUpdate,
        onClose: this.onClose,
        log: this.logDebugData
      };
      return jsxRuntimeExports.jsx("div", { className: "ar-Editor", ref: this.containerRef, children: jsxRuntimeExports.jsx(CanvasWithContext, __assign({}, props)) });
    };
    return Editor2;
  }(Component)
);
export {
  Editor as default
};
